Bug 472425 - Rules don't load properly on boot if using firewall marks
Rules don't load properly on boot if using firewall marks
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: ipvsadm (Show other bugs)
5.2
All Linux
medium Severity medium
: rc
: ---
Assigned To: Marek Grac
BaseOS QE
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-11-20 14:10 EST by Sean E. Millichamp
Modified: 2016-04-26 10:02 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-09-02 08:00:15 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Sean E. Millichamp 2008-11-20 14:10:25 EST
Description of problem:

If the ipvsadm ruleset contains virtual services using fwmarks then the realservers will not load for that virtual service at boot time.  The virtual service loads, but has no real servers in it.

If the startup order of ipvsadm changes from 08 to 11 (after the 'network' service starts) then all of the real servers load properly.  I do not know the root cause, only that network must be started first.

Version-Release number of selected component (if applicable):

ipvsadm-1.24-8.1

How reproducible: Every time.

Steps to Reproduce:

Start on a fresh system.
# yum -y install ipvsadm
# chkconfig ipvsadm on
# ipvsadm -A -f 1
# ipvsadm -a -f 1 -r 192.168.111.111:80
# ipvsadm -L
IP Virtual Server version 1.2.1 (size=4096)
Prot LocalAddress:Port Scheduler Flags
  -> RemoteAddress:Port           Forward Weight ActiveConn InActConn
FWM  1 wlc
  -> 192.168.111.111:http         Route   1      0          0         
# service ipvsadm save
# reboot

<wait for the reboot>

# ipvsadm -L
IP Virtual Server version 1.2.1 (size=4096)
Prot LocalAddress:Port Scheduler Flags
  -> RemoteAddress:Port           Forward Weight ActiveConn InActConn
FWM  1 wlc
# service ipvsadm start
Clearing the current IPVS table:                           [  OK  ]
Applying IPVS configuration:                               [  OK  ]
# ipvsadm -L
IP Virtual Server version 1.2.1 (size=4096)
Prot LocalAddress:Port Scheduler Flags
  -> RemoteAddress:Port           Forward Weight ActiveConn InActConn
FWM  1 wlc
  -> 192.168.222.10:0             Tunnel  10     0          0         

Actual results:

As shown above, the 192.168.111.111 real server is missing until the rules are reloaded.

Expected results:

The rules should load properly in a reboot-safe manner.  Not having them load is an unpleasant surprise.

Additional info:
Comment 1 Lon Hohberger 2008-11-25 11:50:48 EST
Marek - Additional info - this doesn't happen on Fedora 10 Preview:

[root@cracklez ~]# ipvsadm -A -f 1
[root@cracklez ~]# ipvsadm -a -f 1 -r 192.168.111.111:80
[root@cracklez ~]# chkconfig --list ipvsadm
ipvsadm         0:off   1:off   2:off   3:off   4:off   5:off   6:off
[root@cracklez ~]# chkconfig ipvsadm on
[root@cracklez ~]# chkconfig --list ipvsadm
ipvsadm         0:off   1:off   2:on    3:on    4:on    5:on    6:off
[root@cracklez ~]# service ipvsadm save
Saving IPVS table to /etc/sysconfig/ipvsadm:               [  OK  ]
[root@cracklez ~]# service ipvsadm status
IP Virtual Server version 1.2.1 (size=4096)
Prot LocalAddress:Port Scheduler Flags
  -> RemoteAddress:Port           Forward Weight ActiveConn InActConn
FWM  1 wlc
  -> 192.168.111.111:80           Route   1      0          0         
[root@cracklez ~]# cat /etc/sysconfig/ipvsadm 
-A -f 1 -s wlc
-a -f 1 -r 192.168.111.111:80 -g -w 1

(reboot)

[root@cracklez ~]# ipvsadm -L
IP Virtual Server version 1.2.1 (size=4096)
Prot LocalAddress:Port Scheduler Flags
  -> RemoteAddress:Port           Forward Weight ActiveConn InActConn
FWM  1 wlc
  -> 192.168.111.111:http         Route   1      0          0         
[root@cracklez ~]# uptime
 11:32:48 up 0 min,  1 user,  load average: 0.95, 0.27, 0.09
Comment 2 Marek Grac 2009-01-07 09:01:58 EST
Confirmed on RHEL 5. There is also problem with '-m' (masquerade). ipvsadm tries to use IP_VS_SO_* but they are not available. They can be found in ip_vs* modules which are loaded afterwards. So moving startup order to 11 (right after networking) is correct solution.
Comment 5 errata-xmlrpc 2009-09-02 08:00:15 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2009-1398.html

Note You need to log in before you can comment on or make changes to this bug.